# 由和找到两数——数组、哈希表

> 发布于：2022-03-02 | 分类：刷题 | 原文：https://www.imbailey.cn/post/leetcode-1-two-sum-array-hash-table

## 题目

> 该题目来自：https://leetcode-cn.com/problems/two-sum/

#### [1. 两数之和](https://leetcode-cn.com/problems/two-sum/)

难度简单13591收藏分享切换为英文接收动态反馈

给定一个整数数组 `nums` 和一个整数目标值 `target`，请你在该数组中找出 **和为目标值** *`target`* 的那 **两个** 整数，并返回它们的数组下标。

你可以假设每种输入只会对应一个答案。但是，数组中同一个元素在答案里不能重复出现。

你可以按任意顺序返回答案。

 

**示例 1**：

```
输入：nums = [2,7,11,15], target = 9
输出：[0,1]
解释：因为 nums[0] + nums[1] == 9 ，返回 [0, 1] 。
```

**示例 2**：

```
输入：nums = [3,2,4], target = 6
输出：[1,2]
```

**示例 3**：

```
输入：nums = [3,3], target = 6
输出：[0,1]
```

 

**提示**：

- `2 <= nums.length <= 104`
- `-109 <= nums[i] <= 109`
- `-109 <= target <= 109`
- **只会存在一个有效答案**

**进阶**：你可以想出一个时间复杂度小于 `O(n2)` 的算法吗？



## 题解

* 最简单的暴力：

```c++
class Solution {
public:
    vector<int> twoSum(vector<int>& nums, int target) {
        for(int i=0;i<nums.size()-1;i++){
            for(int j=i+1;j<nums.size();j++){
                if(nums[i] + nums[j] == target){
                    return {i, j};
                }
            }
        }
        return {};
    }
};
```

时间复杂度：O(N^2)

空间复杂度：O(1)



* 哈希表：

> 作者：LeetCode-Solution
> 链接：https://leetcode-cn.com/problems/two-sum/solution/liang-shu-zhi-he-by-leetcode-solution/
> 来源：力扣（LeetCode）
> 著作权归作者所有。商业转载请联系作者获得授权，非商业转载请注明出处。

可以优化的地方就是对于每个元素x，寻找target-x可以改用哈希表寻找，速度可以从O(N)降到O(1)。

只遍历一遍nums数组，对于每个x，寻找target-x是否在哈希表中，如果不在就把x插入到哈希表中。

```c++
class Solution {
public:
    vector<int> twoSum(vector<int>& nums, int target) {
        unordered_map<int, int> hashtable;
        for (int i = 0; i < nums.size(); ++i) {
            auto it = hashtable.find(target - nums[i]);
            if (it != hashtable.end()) {
                return {it->second, i};
            }
            hashtable[nums[i]] = i;
        }
        return {};
    }
};
```

时间复杂度：O(N)

空间复杂度：O(N)

**代码解释**：

`hashtable`: 由键-值组成（都是int类型）在这道题里键是nums[i]，值是索引i。

`it->second`: it是迭代器，it->second表示访问值，同理it->first访问键，也可以写成`(*it).second`，`(*it).first`。
